image: docker:latest
services:
  - docker:dind

stages:
  - build
  - deploy

variables:
  CONTAINER_IMAGE: rahulace/ace:${CI_COMMIT_SHORT_SHA}

build:
  stage: build
  script:
    - docker login -u ${DOCKER_USER} -p ${DOCKER_PASSWORD}
    - docker build -t ${CONTAINER_IMAGE} .
    - docker tag ${CONTAINER_IMAGE} ${CONTAINER_IMAGE}
    - docker tag ${CONTAINER_IMAGE} rahulace/ace:latest
    - docker push ${CONTAINER_IMAGE}

deploy:
  stage: deploy
  image: dtzar/helm-kubectl
  script:
    # TODO: Uncomment when decide to use helm, also remove the line direct below the commments.
    # - helm init --client-only
    # - helm upgrade ace ./ --install --set image.tag=${CI_COMMIT_SHORT_SHA} 
    - sed -i "s/<VERSION>/${CI_COMMIT_SHORT_SHA}/g" deployment.yaml
    - kubectl apply -f deployment.yaml
  environment:
    name: production
    url: ${CI_ENVIRONMENT_URL}